//+------------------------------------------------------------------
//|                                                                 |
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//+------------------------------------------------------------------
//|                                                                 |
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
 
   
#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     DeepSkyBlue
#property indicator_color2     Red
#property indicator_color3     DimGray
#property indicator_color4     Gold
#property indicator_color5     Gold
#property indicator_width1     2
#property indicator_style2     STYLE_DASH
#property indicator_style3     STYLE_DOT
#property indicator_level1     50
#property indicator_levelcolor MediumOrchid
#property indicator_levelstyle STYLE_DOT

//
//
//
//
//

extern string TimeFrame                = "Current Time Frame";
extern int    NdoPrice                 = PRICE_CLOSE;
extern int    EMAPeriod                = 15;
extern int    SigMaPeriod              = 3;
extern int    Ma_Mode                  = MODE_SMMA;
extern int    NormPeriod               = 100;
extern int    SmoothLength             = 10;
extern double SmoothPhase              = 0;
extern bool   SmoothDouble             = true;
extern int    HighLowPeriod            = 34;
extern bool   ShowChannel              = true;
extern bool   ShowZigZag               = true;
extern bool   Interpolate              = true;

extern string _                        = "Alerts Settings";
extern bool   alertsOn                 = true;
extern bool   alertsOnDevMaCross       = true;
extern bool   alertsOnHiLoChannelCross = true;
extern bool   alertsOnCurrent          = false;
extern bool   alertsMessage            = true;
extern bool   alertsSound              = true;
extern bool   alertsEmail              = false;

extern bool   arrowsVisible            = true;
extern string arrowsIdentifier         = "norm deviation Arrows1";
extern double arrowsDisplacement       = 1.0;
extern color  arrowsUpColor            = DeepSkyBlue;
extern color  arrowsDnColor            = Red;
extern bool   arrowsOnDevMaCross       = false;
extern bool   arrowsOnHiLoChannelCross = true;

//
//
//
//
//

double ndo[];
double ndma[];
double HighBuffer[];
double LowBuffer[];
double ZigZagBuffer[];
double ZigZagLow[];
double ZigZagHigh[];
double dos[];
double trends[][2];

#define _tmi  0
#define _tup1 1

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
  
int init() 
{
   
   IndicatorBuffers(8);
      SetIndexBuffer(0,ndo);
      SetIndexBuffer(1,ndma);
      SetIndexBuffer(2,ZigZagBuffer);
      SetIndexBuffer(3,HighBuffer);
      SetIndexBuffer(4,LowBuffer);
      SetIndexBuffer(5,ZigZagLow);
      SetIndexBuffer(6,ZigZagHigh);
      SetIndexBuffer(7,dos);
      SetIndexStyle(2,DRAW_SECTION);
      SetIndexEmptyValue(0,0);
      SetIndexEmptyValue(1,0);
      SetIndexEmptyValue(2,0);
      SetIndexEmptyValue(5,0);
      SetIndexEmptyValue(6,0);
      SetIndexLabel(2,NULL);
   
      //
      //
      //
      //
      //
      
         if (ShowChannel)
           {
           SetIndexStyle(3,DRAW_LINE);
           SetIndexStyle(4,DRAW_LINE);
           }
         else      
           {
           SetIndexStyle(3,DRAW_NONE);
           SetIndexStyle(4,DRAW_NONE);
           }
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+"  normalized deviation channel ("+EMAPeriod+","+SigMaPeriod+")");
      
   return(0);
}

//
//
//
//
//

int deinit(){  if (!calculateValue && arrowsVisible) deleteArrows();  return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,j,k,n,r,limit;
   
   int lastZag;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars) { ndo[0] = MathMin(limit+1,Bars-1); return(0); }
           
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
         
   if (ShowZigZag)
   for (lastZag=limit+1; lastZag<Bars; lastZag++) if (ZigZagLow[lastZag] != 0 || ZigZagHigh[lastZag] != 0) break;
   if (ArrayRange(trends,0)!=Bars) {  ArrayResize(trends,Bars); }
   
        for(i = limit, r=Bars-i-1; i>=0; i--,r++)
        {
             dos[i] = iMA(NULL,0,1,0,MODE_SMA,NdoPrice,i) - iMA(NULL,0,EMAPeriod,0,MODE_EMA,NdoPrice,i);
      
             //
             //
             //
             //
             //
         
            double hi     = dos[ArrayMaximum(dos,NormPeriod,i)];
            double lo     = dos[ArrayMinimum(dos,NormPeriod,i)];
         
            if (hi!=lo)
                 ndo[i]   = iDSmooth(100*(dos[i]- lo)/(hi - lo),SmoothLength,SmoothPhase,SmoothDouble,i, 0);        
            else ndo[i]   = iDSmooth(0,                         SmoothLength,SmoothPhase,SmoothDouble,i, 0);        
      
                    
            LowBuffer[i]  = ndo[ArrayMinimum(ndo,HighLowPeriod,i)];
            HighBuffer[i] = ndo[ArrayMaximum(ndo,HighLowPeriod,i)];  
      
      //
      //
      //
      //
      //
      
      if (!ShowZigZag) continue;
      
      ZigZagLow[i]  = 0;
         ZigZagHigh[i] = 0;
         if (LowBuffer[i] < LowBuffer[i+1])
            {
               if (ZigZagBuffer[lastZag] == LowBuffer[lastZag])
                   ZigZagBuffer[lastZag] = 0;
                   ZigZagBuffer[i]       =  LowBuffer[i];
                   ZigZagLow[i]          =  LowBuffer[i];
                                 lastZag = i;
                                 continue;
            }
         if (HighBuffer[i] > HighBuffer[i+1])
            {
               if (ZigZagBuffer[lastZag] == HighBuffer[lastZag])
                   ZigZagBuffer[lastZag] = 0;
                   ZigZagBuffer[i]       =  HighBuffer[i];
                   ZigZagHigh[i]         =  HighBuffer[i];
                                 lastZag = i;
                                 continue;
            }
         if (ZigZagBuffer[i] != 0)
            {
               ZigZagBuffer[i] = 0;
               for (lastZag=i+1; lastZag<Bars; lastZag++)
               {
                  if (ZigZagLow[lastZag]  != 0) { ZigZagBuffer[lastZag] = ZigZagLow[lastZag];  break; }
                  if (ZigZagHigh[lastZag] != 0) { ZigZagBuffer[lastZag] = ZigZagHigh[lastZag]; break; }
               }
               
              } 
              
            setTrends(i,r);
            manageArrow(i,r);
              
    }
    for(i=limit; i>=0; i--)  ndma[i] = iMAOnArray(ndo,Bars,SigMaPeriod,0,Ma_Mode,i);
    manageAlerts();
    return(0);
    }
  
    //
    //
    //
    //
    //
    
    limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    if (ArrayRange(trends,0)!=Bars) ArrayResize(trends,Bars);
    
    if (ShowZigZag)
    for (lastZag=limit+1; lastZag<Bars; lastZag++) if (ZigZagLow[lastZag] != 0 || ZigZagHigh[lastZag] != 0) break;
    
    for(i = limit, r=Bars-i-1; i>=0; i--,r++)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
            ndo[i]          = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,0,y);
            ndma[i]         = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,1,y);
            ZigZagBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,2,y);
            HighBuffer[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,3,y);
            LowBuffer[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,4,y);
            ZigZagLow[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,5,y);
            ZigZagHigh[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,6,y);
  
            setTrends(i,r); 
            manageArrow(i,r);
            
            //
            //
            //
            //
            //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(k = 1; k < n; k++)
               {
                  ndo[i+k]       = ndo[i]       + (ndo[i+n]       - ndo[i])       * k/n;
                  ndma[i+k]      = ndma[i]      + (ndma[i+n]      - ndma[i])      * k/n;
                  HighBuffer[i+k]= HighBuffer[i]+ (HighBuffer[i+n]- HighBuffer[i])* k/n;
                  LowBuffer[i+k] = LowBuffer[i] + (LowBuffer[i+n] - LowBuffer[i]) * k/n;

            //
            //
            //
            //
            //
               
            }  	            
   }
      
   manageAlerts();
      
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}
      
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//
//
//
//
//

void setTrends(int i, int r)
{
   trends[r][_tmi]  = trends[r-1][_tmi];
   trends[r][_tup1] = trends[r-1][_tup1];
   
   
      if (ndo[i] > ndma[i])                                      trends[r][_tmi]  =  1;
      if (ndo[i] < ndma[i])                                      trends[r][_tmi]  = -1;
      if (ndo[i] > LowBuffer[i]  && ndo[i+1] == LowBuffer[i+1])  trends[r][_tup1] =  1;
      if (ndo[i] < HighBuffer[i] && ndo[i+1] == HighBuffer[i+1]) trends[r][_tup1] = -1;
      
}


//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 
                             whichBar = Bars-whichBar-1;

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnDevMaCross && trends[whichBar][_tmi] != trends[whichBar-1][_tmi])
      {
         if (trends[whichBar][_tmi] ==  1) doAlert(time1,mess1,whichBar,"Deviation and Ma Cross Up");
         if (trends[whichBar][_tmi] == -1) doAlert(time1,mess1,whichBar,"Deviation and Ma Cross down");
      }
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnHiLoChannelCross && trends[whichBar][_tup1] != trends[whichBar-1][_tup1])
      {
         if (trends[whichBar][_tup1] ==  1) doAlert(time2,mess2,whichBar,"Lower Channel Cross up");
         if (trends[whichBar][_tup1] == -1) doAlert(time2,mess2,whichBar,"Upper Channel Cross down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," normalized deviation ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," normalized deviation "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i, int r)
{
   if (!calculateValue && arrowsVisible)
   {
      deleteArrow(Time[i]);
      if (arrowsOnDevMaCross && trends[r][_tmi]!=trends[r-1][_tmi])
      {
         if (trends[r][_tmi] == 1) drawArrow(i,arrowsUpColor,241,false);
         if (trends[r][_tmi] ==-1) drawArrow(i,arrowsDnColor,242,true);
      }
      if (arrowsOnHiLoChannelCross && trends[r][_tup1]!=trends[r-1][_tup1])
      {
         if (trends[r][_tup1] == 1) drawArrow(i,arrowsUpColor,241,false);
         if (trends[r][_tup1] ==-1) drawArrow(i,arrowsDnColor,242,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}

//
//
//
//
//

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


